@Echo off
setlocal enabledelayedexpansion
rem #########################################Informationen################################################
rem Version 1.3.1 vom 13.07.2012
rem Dieses Script setzt ein installiertes Robocopy voraus. Ab Windows 7/Server 2008 R2 bereits vorhanden.
rem Die Sicherung erzeugt ein 1-zu-1-Abbild des Quellordners.
rem Dateien, die im Quellordner gelscht wurden, werden auch im Zielordner gelscht.
rem Pfade bitte immer OHNE abschlieenden "\" eingeben.
rem Variable "includedatei": In dieser Datei bitte zweilenweise die zu sichernden Ordner/Laufwerke angeben.
rem Variable "sqlscript":    In diese Datei eintragen, welche DBs mitgesichert werden sollen.
rem Variable "scriptpfad":	 Pfad zum Backupscript.
rem Variable "logging":      - wenn "ja" wird das Log in eine Datei geschrieben.
rem                          - wenn "nein" wird alles auf dem Bildschirm ausgegeben.
rem Variable "sql":			 Sollen SQL-DBs mitgesichert werden? Setzt "sqlscript" voraus! ja/nein
rem Variable "backupordner": Legt fest, ob fr jede/n Laufwerksbuchstaben/Freigabe ein Unterordner auf dem
rem							 Zieldatentrger angelegt werden soll. ja/nein
rem 						 !!! NUR AUF NEIN, WENN ES NUR 1 QUELLLAUFWERK/-ORDNER GIBT !!!
rem Variable "sqlserver":    Name\Instanz des SQL-Servers.
rem Variable "einleitung":   Das steht in der Kopfzeile der Log-Datei. Z.B. "Was wird gesichert".
rem Variable "dirausnahme":	 Hier mit Leerzeichen voneinander getrennt die Verzeichnisse eintragen,
rem							 die nicht mitgesichert werden sollen. Wenn ein Leerzeichen im 
rem							 Verzeichnisnamen vorkommt, dann den kompletten Ordnernamen in "" eintragen.
rem Variable "fileausnahme": Hier mit Leerzeichen voneinander getrennt die Dateien eintragen, die nicht
rem							 mitgesichert werden sollen. Wenn ein Leerzeichen im Dateinamen vorkommt,
rem							 dann den Dateinamen in "" angeben. Wildcards sind erlaubt.

rem #########################################Variablen setzen##############################################
rem ##Pfade und Dateien##
set ziel="E:"
set logdateipfad=c:\Backup\LOG
set includedatei=c:\Backup\backup.inc
set sqlscript=c:\Backup\sichern.sql
set scriptpfad=c:\Backup

rem ##Abfragen##
set logging=nein
set sql=nein
set backupordner=ja

rem ##Sonstiges##
set sqlserver=SQL
set einleitung=Datensicherung
set dirausnahme=/XD $RECYCLE.BIN "System Volume Information" MSOCache
set fileausnahme=/XF hiberfil.sys pagefile.sys ntuser.*
rem #######################################################################################################

rem ####ab hier beginnt das Script####

rem ####Logging abfragen####
if %logging% == ja goto :LOG
if %logging% == nein goto :NOLOG

rem ####Sicherung mit Logging####
:LOG

rem ##Log-Dateien rotieren##
echo Sicherungsprotokolle werden verschoben...
if exist %logdateipfad%\backup9.log del /Q %logdateipfad%\backup9.log
if exist %logdateipfad%\backup8.log move %logdateipfad%\backup8.log %logdateipfad%\backup9.log
if exist %logdateipfad%\backup7.log move %logdateipfad%\backup7.log %logdateipfad%\backup8.log
if exist %logdateipfad%\backup6.log move %logdateipfad%\backup6.log %logdateipfad%\backup7.log
if exist %logdateipfad%\backup5.log move %logdateipfad%\backup5.log %logdateipfad%\backup6.log
if exist %logdateipfad%\backup4.log move %logdateipfad%\backup4.log %logdateipfad%\backup5.log
if exist %logdateipfad%\backup3.log move %logdateipfad%\backup3.log %logdateipfad%\backup4.log
if exist %logdateipfad%\backup2.log move %logdateipfad%\backup2.log %logdateipfad%\backup3.log
if exist %logdateipfad%\backup1.log move %logdateipfad%\backup1.log %logdateipfad%\backup2.log

rem ##Wochentag ermitteln##
call:Wochentag

rem ##neue LOG-Datei erzeugen und Einleitung einfgen##
echo %einleitung% > %logdateipfad%\backup1.log
echo. >> %logdateipfad%\backup1.log

rem ##Startzeit in Logdatei schreiben##
echo Datensicherung gestartet am %WoTa% den %date% um %time:~0,8% Uhr. >> %logdateipfad%\backup1.log
echo. >> %logdateipfad%\backup1.log

rem ####Zieldatentrger berprfen####
if not exist %ziel% (
	echo Der Zieldatentrger ist nicht eingelegt oder funktioniert nicht. >> %logdateipfad%\backup1.log
	echo. >> %logdateipfad%\backup1.log
	goto :ENDE
)

rem ##SQL sichern, falls aktiv##
if %sql% == ja (
	echo SQL-Sicherung gestartet >> %logdateipfad%\backup1.log
	echo. >> %logdateipfad%\backup1.log
	sqlcmd.exe -S %sqlserver% -E -i %sqlscript% >> %logdateipfad%\backup1.log
	echo. >> %logdateipfad%\backup1.log
	echo SQL-Sicherung beendet >> %logdateipfad%\backup1.log
)

rem ##Sicherung mit Umleitung der Ausgabe in die LOG-Datei##
echo. >> %logdateipfad%\backup1.log
echo Sicherung wurde gestartet... >> %logdateipfad%\backup1.log
echo. >> %logdateipfad%\backup1.log

rem ##includedatei einlesen und sichern##
FOR /f "delims=*" %%i in (%includedatei%) do (
	if [%%~nxi] == [] (
		set str=%%i
		set str=!str:~0,1!
		if %backupordner% == ja (
			if not exist "%ziel%\LW !str!" md "%ziel%\LW !str!"
			robocopy "%%i" "%ziel%\LW !str!" /S /PURGE /NP /NDL /R:1 /W:1 /LOG+:"%logdateipfad%\backup1.log" %dirausnahme% %fileausnahme%
			attrib -H -S "%ziel%\LW !str!" > %scriptpfad%\temp.txt
		) else (
			robocopy "%%i" "%ziel%" /S /PURGE /NP /NDL /R:1 /W:1 /LOG+:"%logdateipfad%\backup1.log" %dirausnahme% %fileausnahme%
			attrib -H -S "%ziel%" > %scriptpfad%\temp.txt		
		)
		echo. >> %logdateipfad%\backup1.log
		echo. >> %logdateipfad%\backup1.log
		echo ############################################################################################ >> %logdateipfad%\backup1.log
		echo. >> %logdateipfad%\backup1.log		
	) else (
		if %backupordner% == ja (
			if not exist "%ziel%\%%~nxi" md "%ziel%\%%~nxi"
			robocopy "%%i" "%ziel%\%%~nxi" /S /PURGE /NP /NDL /R:1 /W:1 /LOG+:"%logdateipfad%\backup1.log" %dirausnahme% %fileausnahme%
			attrib -H -S "%ziel%\%%~nxi" > %scriptpfad%\temp.txt
		) else (
			robocopy "%%i" "%ziel%" /S /PURGE /NP /NDL /R:1 /W:1 /LOG+:"%logdateipfad%\backup1.log" %dirausnahme% %fileausnahme%
			attrib -H -S "%ziel%" > %scriptpfad%\temp.txt
		)
		echo. >> %logdateipfad%\backup1.log
		echo. >> %logdateipfad%\backup1.log
		echo ############################################################################################ >> %logdateipfad%\backup1.log
		echo. >> %logdateipfad%\backup1.log
	)
)

rem ##Wochentag ermitteln##
call:Wochentag

echo. >> %logdateipfad%\backup1.log
echo Sicherung wurde beendet am %WoTa% den %date% um %time:~0,8% Uhr. >> %logdateipfad%\backup1.log
echo. >> %logdateipfad%\backup1.log

rem ##zum Ende des Scripts springen##
goto :ENDE

rem ####Sicherung ohne Logging####
:NOLOG
echo %einleitung%
echo.
echo Sicherung wurde gestartet...
echo.

rem ####Zieldatentrger berprfen####
if not exist %ziel% (
	echo Der Zieldatentrger ist nicht eingelegt oder funktioniert nicht.
	echo.
	pause
	goto :ENDE
)

rem ##SQL sichern, falls aktiv##
if %sql% == ja (
	echo SQL-Sicherung gestartet, bitte warten...
	sqlcmd.exe -S %sqlserver% -E -i %sqlscript%
	echo SQL-Sicherung beendet
)

rem ##includedatei einlesen und sichern##
FOR /f "delims=*" %%i in (%includedatei%) do (
	if [%%~nxi] == [] (
		set str=%%i
		set str=!str:~0,1!
		if %backupordner% == ja (
			if not exist "%ziel%\LW !str!" md "%ziel%\LW !str!"
			robocopy "%%i" "%ziel%\LW !str!" /S /PURGE /NDL /R:1 /W:1 %dirausnahme% %fileausnahme%
			attrib -H -S "%ziel%\LW !str!" > %scriptpfad%\temp.txt
		) else (
			robocopy "%%i" "%ziel%" /S /PURGE /NDL /R:1 /W:1 %dirausnahme% %fileausnahme%
			attrib -H -S "%ziel%" > %scriptpfad%\temp.txt
		)
		echo.
	) else (
		if %backupordner% == ja (
			if not exist "%ziel%\%%~nxi" md "%ziel%\%%~nxi"
			robocopy "%%i" "%ziel%\%%~nxi" /S /PURGE /NDL /R:1 /W:1 %dirausnahme% %fileausnahme%
			attrib -H -S "%ziel%\%%~nxi" > %scriptpfad%\temp.txt
		) else (
			robocopy "%%i" "%ziel%" /S /PURGE /NDL /R:1 /W:1 %dirausnahme% %fileausnahme%
			attrib -H -S "%ziel%" > %scriptpfad%\temp.txt
		)
		echo.
	)
)
echo.
echo Sicherung wurde beendet...
echo.

rem ##Funktion Wochentag ermitteln##
:Wochentag
	FOR /F "tokens=1,2,3 delims=." %%a in ('echo %date%') do set yy=%%c & set mm=%%b & set dd=%%a
	set /a "TwoDigitYearMax=2038%%1000"
	if 1%yy% LSS 200 if 1%yy% LSS 1%TwoDigitYearMax% (set yy=20%yy%) else (set yy=19%yy%)
	set /a dd=100%dd%%%100,mm=100%mm%%%100
	set /a z=14-mm,z/=12,y=yy+4800-z,m=mm+12*z-3,dow=153*m+2
	set /a dow=dow/5+dd+y*365+y/4-y/100+y/400-2472630,dow%%=7,dow+=1
	If %dow% equ 1 set "WoTa=Montag"
	If %dow% equ 2 set "WoTa=Dienstag"
	If %dow% equ 3 set "WoTa=Mittwoch"
	If %dow% equ 4 set "WoTa=Donnerstag"
	If %dow% equ 5 set "WoTa=Freitag"
	If %dow% equ 6 set "WoTa=Samstag"
	If %dow% equ 7 set "WoTa=Sonntag"
goto:eof

:ENDE

endlocal